-- Display a message in the console for debugging
function Msg(value)
  if console then
    reaper.ShowConsoleMsg(tostring(value) .. "\n")
  end
end

console = true -- true/false: display debug messages in the console

--reaper.PreventUIRefresh(1)

function sleep(s)
  local ntime = os.time() + s
  repeat until os.time() > ntime
end

function reatrak_selection()

      Info1 = [[ reatrak_selection() next]]
      reaper.MB(Info1, "Paused", 0)

      commandID10 = reaper.NamedCommandLookup("_0aaf7120a177a044b41d609683934470")
      reaper.Main_OnCommand(commandID10, 0) --  Custom: ReaTrak selection

--[[
      commandID10 = reaper.NamedCommandLookup("_RS36f146bbf2f5b41d41315020d307f6b50c4ccbac")
      reaper.Main_OnCommand(commandID10, 0) --  Script: ReaTrak move cursor to time selection.lua
      sleep(.1)
      reaper.Main_OnCommand(40058, 0) --  Item: Paste items/tracks

      sleep(.1)
      reaper.Main_OnCommand(41173, 0) --  Item navigation: Move cursor to start of items
            
      item = reaper.GetSelectedMediaItem(0, 0) 
      --_take = reaper.GetMediaItemTake(item, 0)
      take = reaper.GetActiveTake(item)
      retval, take_name = reaper.GetSetMediaItemTakeInfo_String( take, "P_NAME", "", false )
      org_bpm = tonumber(take_name:match('(%d+)bpm')) or 120
      playrate = bpm / org_bpm
      reaper.SetMediaItemTakeInfo_Value( take, "D_PLAYRATE", playrate )
      
      sleep(.1)
      commandID11 = reaper.NamedCommandLookup("_RSef3a489d9791ceb057ab746d66b82ba461bb33d1")
      reaper.Main_OnCommand(commandID11, 0) --  Script: ReaTrak Split to regions CSV.lua
    
      sleep(.1)
    
      commandID12 = reaper.NamedCommandLookup("_RSd396b5c9d44a2318be8cf27878cc081ca5c5ba9c")
      reaper.Main_OnCommand(commandID12, 0) --  Script: ReaTrak Move and match.lua
--]]

end      


    tempo_markers_count = reaper.CountTempoTimeSigMarkers(0)
    
    if tempo_markers_count > 0 then
    
      cur_pos = reaper.GetCursorPosition()
      
      --retval_split,input_yes  = reaper.GetUserInputs("Region Split to Tempo Map", 1, "Split Regions @ Tempo changes ?", "yes")
      commandID1 = reaper.NamedCommandLookup("_RS3628f83c9f311bd67b97be26bb47f9d76c5cbaf9")
      reaper.Main_OnCommand(commandID1, 0) -- Script: ReaTrak Export regions as file.lua

      regions_saved = 1
      
      commandID4 = reaper.NamedCommandLookup("_RS3374194533e692527a47ca4ede0688a20fd691fd")
      reaper.Main_OnCommand(commandID4, 0) -- Script: ReaTrak split regions at tempo markers.lua
      
      
      commandID3 = reaper.NamedCommandLookup("_SWSMARKERLIST8")
      reaper.Main_OnCommand(commandID3, 0) -- SWS: Renumber region IDs  
      
      reaper.SetEditCurPos2( 0, cur_pos, 0, 0 )

    

      start_time1, end_time1 = reaper.GetSet_LoopTimeRange2(0, false, false, 0, 0, false)
      
      for i = 0, tempo_markers_count  do
      
        
        
        start_time, end_time = reaper.GetSet_LoopTimeRange2(0, false, false, 0, 0, false)
                 
        retval, timepos, measurepos, beatpos, bpm, timesig_num, timesig_denom, lineartempo = reaper.GetTempoTimeSigMarker( 0, i )
      
        retval, timepos2, measurepos, beatpos, bpm2, timesig_num, timesig_denom, lineartempo = reaper.GetTempoTimeSigMarker( 0, i+1 )
        
        if timepos >= start_time1 and timepos2 <= end_time1 and i < tempo_markers_count -1 then
           
           startpos = timepos
           
           endpos = timepos2
           
           start_time2, end_time2 = reaper.GetSet_LoopTimeRange2( 0, true, false, startpos, endpos, 0 )
           
           reatrak_selection() 
           
        end

        
        if i == tempo_markers_count -1 then 
           
           startpos = timepos
           
           endpos = end_time1
           
           start_time2, end_time2 = reaper.GetSet_LoopTimeRange2( 0, true, false, startpos, endpos, 0 )
           
           reatrak_selection()
        
        end 
      
        if i == tempo_markers_count -1 then break end
        
      
      end
  
  
  end

    
    
    if regions_saved == 1 then
      
      commandID1 = reaper.NamedCommandLookup("_RS1c82e587d259e8ea79f40a64b7a92feb8450e477")
      reaper.Main_OnCommand(commandID1, 0) -- Script: ReaTrak Import regions from file.lua
      
      start_time, end_time = reaper.GetSet_LoopTimeRange2( 0, true, false, start_time1, end_time1, 0 )
    
    end    

  if tempo_markers_count < 1 then  reatrak_selection() end    
    
    
--reaper.PreventUIRefresh(-1)    
